<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Judul, nomor inventaris" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                    <el-button @click="showFilterDialog = true" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-funnel"></i> Filter
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'inventory', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Inventaris
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="inventories" ref="inventoryTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="No. Inventaris"
                width="200">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.number }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Tanggal Diterima"
                width="150">
                <template slot-scope="scope">
                    <span>{{ dateFormat(scope.row.received_date, 'DD/MM/YYYY') }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Kategori"
                width="100">
                <template slot-scope="scope">
                    <span>{{ scope.row.category.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Nama Barang"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.title }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Deskripsi"
                width="250">
                <template slot-scope="scope">
                    <span>{{ scope.row.description }}</span>
                </template>
            </el-table-column>            
            <el-table-column
                align="center"
                label="Kuantitas"
                width="100">
                <template slot-scope="scope">
                    <span>{{ scope.row.quantity }}</span>
                </template>
            </el-table-column> 
            <el-table-column
                align="center"
                label="Keluar"
                width="100">
                <template slot-scope="scope">
                    <span>{{ scope.row.movements.length }}</span>
                </template>
            </el-table-column> 
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'inventory', 'viewown']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'inventory', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="filterLoading" title="Filter" :visible.sync="showFilterDialog" width="30%" :show-close="false" @closed="resetForm">
            <aside>
                <el-alert type="info" description="Tampilkan data barang inventaris berdasarkan kriteria di bawah" :closable=false show-icon></el-alert>
            </aside>
            <el-form ref="filter" :model="filter">
                <el-form-item label="Kata Kunci" prop="keyword">
                    <el-input ref="keyword" name="keyword" v-model="filter.keyword" placeholder="No. inventaris, judul" autocomplete="off" maxlength="255" clearable></el-input>
                </el-form-item>
                <el-row :gutter="20">                    
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Kategori" prop="category">
                            <el-select v-model="filter.category" placeholder="Pilih kategori" class="width-100" ref="category" name="category" clearable>
                                <el-option
                                    v-for="item in categories"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                        <el-form-item label="Perumahan" prop="residential">
                            <el-select v-model="filter.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential" clearable>
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>             
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showFilterDialog = false" size="medium">Batal</el-button>
                <el-button @click="handleSearch" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> Submit
                </el-button>
            </span>
        </el-dialog>

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="inventoryForm" :model="inventoryForm" :rules="inventoryRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar semua barang inventaris masing-masing perumahan." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Nama" prop="title">
                    <el-input ref="title" name="title" v-model="inventoryForm.title" placeholder="Nama barang inventaris" autocomplete="off" maxlength="255" show-word-limit></el-input>
                </el-form-item>  
                <el-form-item label="Deskripsi" prop="description">
                    <el-input type="textarea" ref="description" name="description" v-model="inventoryForm.description" placeholder="Catatan" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                </el-form-item>      
                <el-row :gutter="20">
                    <el-col :lg="8" :md="24" :sm="24">
                        <el-form-item label="Kategori" prop="category">
                            <el-select v-model="inventoryForm.category" placeholder="Pilih kategori" class="width-100" ref="category" name="category">
                                <el-option
                                    v-for="item in categories"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="8" :md="24" :sm="24">
                        <el-form-item label="Tanggal Diterima" prop="received_date">
                            <el-date-picker
                                format="yyyy-MM-dd" 
                                value-format="yyyy-MM-dd" 
                                :clearable="false" 
                                :editable="false"
                                :default-value="inventoryForm.received_date"
                                v-model="inventoryForm.received_date"
                                type="date"
                                placeholder="Pilih tanggal">
                            </el-date-picker>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="8" :md="24" :sm="24">
                        <el-form-item label="Kuantitas" prop="quantity">
                            <el-input-number v-model="inventoryForm.quantity" ref="quantity" name="quantity" :min="1"></el-input-number>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Inventaris Untuk Perumahan" prop="residential">
                            <el-select v-model="inventoryForm.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential">
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col> 
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Dibuat Oleh" prop="author" clearable>
                            <el-select 
                                v-model="inventoryForm.author" 
                                placeholder="Ketik nama warga" 
                                class="width-100" 
                                ref="author" 
                                name="author"
                                clearable
                                filterable
                                remote
                                :remote-method="getUsers"
                                value-key="id"
                                >
                                <el-option
                                    v-for="item in users"
                                    :key="item.id"
                                    :label="item.profile.fullname"
                                    :value="item.id">
                                    <span style="float: left">{{ item.profile.fullname }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.role.name }}</strong>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>   
                </el-row>             
                <el-form-item label="" prop="medias">
                    <el-upload
                        name="media"
                        :action="uploadURL"
                        with-credentials
                        accept=" .jpg, .jpeg, .png, .doc, .docx, .xls, .xlsx, .pdf"
                        :headers="{'Authorization': 'Bearer ' + token.access_token}"
                        :on-success="handleUploadSuccess"
                        :on-remove="handleUploadRemove"
                        :before-upload="beforeUpload"
                        :file-list="uploadFileList">
                        <el-button size="small" type="primary">Lampiran</el-button>
                        <div slot="tip" class="el-upload__tip">Tipe file: jpg, png, doc/docx, xls/xlsx, pdf</div>
                    </el-upload>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'inventory', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>                
            </span>
        </el-dialog>

    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'Inventory',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        var validateResidential = (rule, value, callback) => {
            if(['root', 'owner'].indexOf(this.me.role.slug) > -1 && this.inventoryForm.residential == null){
                return callback(new Error('Perumahan wajib dipilih'));
            }
            callback();
        };

        var validateAuthor = (rule, value, callback) => {
            if(['root', 'owner'].indexOf(this.me.role.slug) > -1 && this.inventoryForm.residential != null && this.inventoryForm.author == null){
                return callback(new Error('Inventaris dibuat oleh wajib dipilih'));
            }
            callback();
        };

        return {            
            tableLoading: false,
            dialogLoading: false,
            filterLoading: false,
            inventoryStatusTitle: {
                available: 'Tersedia',
                onloan: 'Sedang Dipinjam',
                rentedout: 'Sedang Disewa',
                beingrepaired: 'Sedang Diperbaiki',
                outoforder: 'Rusak',
                missing: 'Hilang'
            },
            filter: {
                keyword: '',
                status: null,
                category: null,
                residential: null
            },
            showDialog: false,
            showFilterDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Inventaris',
                create: 'Tambah Inventaris'
            },
            inventoryForm: {
                id: null,
                title: null,
                description: '',
                quantity: 1,
                received_date: new Date(),
                category: null,
                author: null,
                residential: null,
                archived: false,
                medias: []
            },
            inventoryRules: {
                title: [{ 
                    required: true, message: 'Judul barang inventaris wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang Judul barang inventaris maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,?]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                category: [{
                    required: true, message: 'Kategori barang inventaris wajib diisi', trigger: 'change'
                }],
                residential: [{
                    validator: validateResidential, trigger: 'change'
                }],
                author: [{
                    validator: validateAuthor, trigger: 'change'
                }],
                quantity: [{ required: true, message: 'Kuantitas barang inventaris wajib diisi', trigger: 'blur'}]
            },
            uploadFileList: [],
            uploadURL: ''
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('auth', ['token']),
        ...mapGetters('user', ['me', 'users']),
        ...mapGetters('category', ['categories']),
        ...mapGetters('residential', ['residentials']),
        ...mapGetters('inventory', [
            'inventories',
            'pagination'
        ]),
    },
    created() {
        this.getInventories();
        this.getCategories();
        this.getResidentials();
    },
    methods: {
        playSound,
        dateFormat,
        getInventories() {
            this.tableLoading = true;
            this.$store.dispatch('inventory/getInventories', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getCategories() {
            this.tableLoading = true;
            this.$store.dispatch('category/getCategories', {
                module: 'inventory',
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getResidentials() {
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getUsers() {
            this.tableLoading = true;
            this.$store.dispatch('user/getUsers', {
                residential: this.inventoryForm.residential,
                page: this.pagination.page,
                perpage: 100
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){

            this.showFilterDialog = false;

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            if(this.filter.residential != null){
                payload['residential'] = this.filter.residential;
            }

            if(this.filter.category != null){
                payload['category'] = this.filter.category;
            }

            this.tableLoading = true;
            this.$store.dispatch('inventory/getInventories', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.uploadURL = 'http://api.ringsatu.id/v1/media/tmp';
            this.$nextTick(() => {
                this.$refs['inventoryForm'].clearValidate();
            });
        },
        handleEdit(inventory){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.uploadURL = 'http://api.ringsatu.id/v1/media/inventory/'+inventory.id
            this.inventoryForm.id = inventory.id;
            this.inventoryForm.title = inventory.title;
            this.inventoryForm.description = inventory.description;
            this.inventoryForm.quantity = inventory.quantity;
            this.inventoryForm.received_date = inventory.received_date;
            this.inventoryForm.category = inventory.category.id;
            this.inventoryForm.author = inventory.author.id; 
            this.inventoryForm.residential = inventory.residential.id; 
            this.inventoryForm.archived = inventory.archived;

            if(inventory.medias != null){
                for(const i of inventory.medias){
                    this.inventoryForm.medias.push(i.id);
                    this.uploadFileList.push({
                        id: i.id,
                        name: i.original_filename
                    });
                }
            }else{
                this.inventoryForm.medias = inventory.medias;
            }

            this.getUsers(inventory.author.profile.fullname);

            this.$nextTick(() => {
                this.$refs['inventoryForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.inventoryForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'inventory/addInventory';
                        payload = {
                            title: this.inventoryForm.title,
                            description: this.inventoryForm.description,
                            quantity: this.inventoryForm.quantity,
                            received_date: this.inventoryForm.received_date,
                            category: this.inventoryForm.category,
                            author: this.inventoryForm.author,
                            residential: this.inventoryForm.residential,
                            medias: this.inventoryForm.medias
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'inventory/editInventory';
                        payload = {
                            id: this.inventoryForm.id,title: this.inventoryForm.title,
                            description: this.inventoryForm.description,
                            quantity: this.inventoryForm.quantity,
                            received_date: this.inventoryForm.received_date,
                            category: this.inventoryForm.category,
                            author: this.inventoryForm.author,
                            residential: this.inventoryForm.residential,
                            medias: this.inventoryForm.medias,
                            archived: this.inventoryForm.archived
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(inventory){
            this.$confirm('Anda mencoba untuk menghapus data barang inventaris, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('inventory/deleteInventory', {
                    id: inventory.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.inventoryForm = {
                id: null,
                title: null,
                description: '',
                quantity: 1,
                received_date: new Date(),
                category: null,
                author: null,
                residential: null,
                archived: false,
                medias: []
            }

            this.uploadFileList = [];
        },
        beforeUpload(file) {
            if (['image/jpeg', 'image/png', 'application/pdf', 'application/msword', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/vnd.ms-excel', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', 'application/wps-office.docx', 'application/wps-office.doc', 'application/wps-office.xlsx', 'application/wps-office.xls',].indexOf(file.type) < 0) {
                this.$message.error('Hanya image dengan tipe file jpg, png, doc/docx, xls/xlsx dan pdf yang diperbolehkan.');
                return false;
            }
            if (file.size > (8 * 1024 * 1024)) {
                this.$message.error('Ukuran file tidak boleh lebih dari 8MB.');
                return false;
            }
            return true;
        },
        handleUploadSuccess(res) {
            this.inventoryForm.medias.push(res.data.media.id);
            this.uploadFileList.push({
                name: res.data.media.original_filename,
                id: res.data.media.id
            });
        },
        handleUploadRemove(file){
            for(const i of this.uploadFileList){
                if(i.id === file.id){
                    this.uploadFileList.splice(i, 1);
                    break;
                }
            }

            let action = '';
            let params = {};

            if(this.dialogStatus == 'create'){
                action = 'media/deleteMediaTmp';
                params.id = file.id;
            }else{
                action = 'media/deleteMedia';
                params.id = file.id;
                params.endpoint = 'inventory';
            }

            this.$store.dispatch(action, params).then((response) => {
                if('errors' in response){
                    let error = parseError(response.errors);
                    this.$message.error({
                        message: error.messages
                    });
                }else{
                    this.$message.success({
                        message: response.message
                    });
                }

                this.playSound();
            });
        },
    }

}
</script>
